datablock PlayerData(Player2DNorth : PlayerStandardArmor)
{
	uiName = "2D Player - North";

	canJet = false;
	is2DPlayer = true;

	thirdPersonOnly = true;
	firstPersonOnly = false;

	maxLookAngle = 0;
	minLookAngle = 0;

	maxSideSpeed = 0;

	cameraDirection2D = 0;
};

datablock PlayerData(Player2DSouth : Player2DNorth)
{
	uiName = "2D Player - South";
	cameraDirection2D = 1;
};

datablock PlayerData(Player2DEast : Player2DNorth)
{
	uiName = "2D Player - East";
	cameraDirection2D = 2;
};

datablock PlayerData(Player2DWest : Player2DNorth)
{
	uiName = "2D Player - West";
	cameraDirection2D = 3;
};

package Event_2DCamera
{
	function Armor::onNewDataBlock(%this, %obj)
	{
		Parent::onNewDataBlock(%this, %obj);

		if(%obj.dataBlock.is2DPlayer)
			%direction = %obj.dataBlock.cameraDirection2D;
		else
			%direction = 4;

		%obj.client.schedule(0, set2DCamera, %direction, %obj.dataBlock.cameraPitch2D, %obj.dataBlock.cameraDistance2D);
	}

	function Player::SetDataBlock(%this, %dataBlock)
	{
		Parent::SetDataBlock(%this, %dataBlock);

		if(%dataBlock.is2DPlayer)
			%direction = %dataBlock.cameraDirection2D;
		else
			%direction = 4;

		%this.client.schedule(0, set2DCamera, %direction, %dataBlock.cameraPitch2D, %dataBlock.cameraDistance2D);
	}

	function GameConnection::spawnPlayer(%this, %spawnPoint)
	{
		%return = Parent::spawnPlayer(%this, %spawnPoint);

		if(isObject(%player = %this.player))
		{
			if(%player.dataBlock.is2DPlayer)
				%direction = %player.dataBlock.cameraDirection2D;
			else
				%direction = 4;
		}

		%this.schedule(0, set2DCamera, %direction, %player.dataBlock.cameraPitch2D, %player.dataBlock.cameraDistance2D);

		return %return;
	}
};
activatePackage(Event_2DCamera);