if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	  
	RTB_registerPref("Enable Commands", "2D Camera Events", "$Pref::Server::2DCameraUseCommands", "bool", "Event_2DCamera", true, false, false);
	
	RTB_registerPref("Players - Default Pitch", "2D Camera Events", "$Pref::Server::2DCameraPlayerPitch", "int -360 360", "Event_2DCamera", "25", false, false);
	RTB_registerPref("Players - Default Distance", "2D Camera Events", "$Pref::Server::2DCameraPlayerDistance", "int 5 25", "Event_2DCamera", "15", false, false);
	RTB_registerPref("Players - Default Direction", "2D Camera Events", "$Pref::Server::2DCameraPlayerDirection", "list North 0 South 1 East 2 West 3", "Event_2DCamera", "0", false, false);
}

if($Pref::Server::2DCameraUseCommands $= "")
	$Pref::Server::2DCameraUseCommands = true;

if($Pref::Server::2DCameraPlayerPitch $= "")
	$Pref::Server::2DCameraPlayerPitch = "25";

if($Pref::Server::2DCameraPlayerDistance $= "")
	$Pref::Server::2DCameraPlayerDistance = "15";

if($Pref::Server::2DCameraPlayerDirection $= "")
	$Pref::Server::2DCameraPlayerDirection = "0";

function GameConnection::Set2DCamera(%this, %direction, %pitch, %minDist)
{
	%camera = %this.camera;

	if(!isObject(%player = %this.player) || !isObject(%camera))
		return;

	if(%direction == 4) // None
	{
		%this.setControlObject(%player);
		return;
	}

	if(%direction > 4 || %direction < 0)
		%direction = $Pref::Server::2DCameraPlayerDirection;

	if(%pitch $= "")
		%pitch = $Pref::Server::2DCameraPlayerPitch;

	if(%minDist $= "")
		%minDist = $Pref::Server::2DCameraPlayerDistance;

	if(%direction $= "")
		%direction = $Pref::Server::2DCameraPlayerDirection;

	// I did these next two if statements this way to make it more flexible

	if(%pitch > 0 && %pitch % 90 == 0 && %pitch % 180 != 0) // eulerToAxis breaks when the pitch is divisible by 90 but not divisible by 180
		%pitch--;

	if(%pitch < 0 && strPos(%pitch / 90, ".") == -1 && strPos(%pitch / 180, ".") != -1) // fucking modulus doesn't work with negative numbers
		%pitch++;

	switch(%direction) // so much for making it flexible...
	{
		case 0: // North
		%direction = -%pitch SPC "0 0";

		case 1: // South
		%direction = %pitch SPC "0 180";

		case 2: // East
		%direction = "0" SPC -%pitch SPC "-90";

		case 3: // West
		%direction = "0" SPC %pitch SPC "90";
	}

	%camera.setFlyMode();
	%camera.mode = "Observer";

	%camera.setTransform(%player.getTransform());

	%this.setControlObject(%camera);
	%camera.setControlObject(%player);

	%camera.setOrbitMode(%player, %camera.getPosition() SPC eulerToAxis(%direction), -%minDist, 0, 0, 0);
	%this.bottomPrint(" ", 1, true); // To prevent the "1 observer(s) thing"
}

registerOutputEvent(GameConnection, "set2DCamera", "list North 0 South 1 East 2 West 3 None 4\tint -360 360 5\tint 5 25 10");

function serverCmdResetCamera(%client)
{
	if(!%client.isAdmin)
		return;

	if(!isObject(%player = %client.player) || !$Pref::Server::2DCameraUseCommands)
		return;

	%client.setControlObject(%player);
}

function serverCmdSet2DCamera(%client, %direction, %pitch, %minDist)
{
	if(!%client.isAdmin || !$Pref::Server::2DCameraUseCommands)
		return;

	%client.set2DCamera(%direction, %pitch, %minDist);
}

function eulerToAxis(%euler) // Credit to Trader for this
{
	%euler = vectorScale(%euler, $pi / 180);
	%matrix = matrixCreateFromEuler(%euler);
	return getWords(%matrix, 3, 6);
}

exec("./players.cs");